#include <stdio.h>

/*
                        +--------------------+
                        |                    |
                        |Declaracin de tipos|
                        |                    |
                        +--------------------+

  El uso de typedef permite llamar FichaAlumno a toda la declaracin de la 
  estructura struct FichaAlumno. De este modo se logra un cdigo ms
  compacto
*/

typedef struct FichaAlumno {
  char apellidos[30];
  char nombre[15];
  unsigned char edad;
  float talla;
} Ficha;


/*
  Con este tupedef se consigue el tipo PunteroDeFuncion, al cual pertenecen
  los punteros de todas las funciones que no devuelven valor alguno (void)
  y que admiten como argumento un puntero de ficha de alumno (Ficha *).
  Este tipo se emplea en la definicin de la funcin iterador.
*/

typedef void (*PunteroDeFuncion)(Ficha *);
/*
                    +-------------------------+
                    |                         |
                    |Declaracin de prototipos|
                    |                         |
                    +-------------------------+

*/
int iterador(Ficha * p, int numElementos, PunteroDeFuncion procesar);

void imprimir(Ficha * p);
void imprimir2(Ficha * p);

/*
  El programa principal queda reducido a la mnima expresin.
  Adems, basta cambiar imprimir por imprimir2 para tener un comportamiento
  completamente distinto.
*/
int main(int argc, char *argv[])
{
    Ficha lista[] = {
                            {"Garca Prez", "Primero", 19, 1.80},
                            {"Rodrguez Rodrguez", "Segundo", 17, 1.62},
                            {"Garca Prez", "Tercero", 19, 1.80},
                            {"","",0,0}
                         };
    iterador(lista,3,&imprimir);
  return 0;
}

int iterador(Ficha * p, int numElementos, PunteroDeFuncion procesar)
{
  int i;
  for(i=0; i<numElementos;i++)
    procesar(p+i);
  return 0;
}

void imprimir(Ficha * p)
{
  printf("%30s%16s%4d%6.2f\n", p->apellidos,
                               p->nombre,
                               p->edad,
                               p->talla);
}

void imprimir2(Ficha * p)
{
  printf("D. %s %s, de %d aos de edad y %.2f metros de talla.\n",
                               p->nombre,
                               p->apellidos,
                               p->edad,
                               p->talla);
}
