#include "cda.h"
/*
	Constructor, destructor y ayuda
	-            -            -
*/
void arranque(GlobRef g, int argc, char * argv[])
{
	FILE * fp;
	fp = fopen("datos.bin", "r");
	long numBytesArchivo = 0, numRegistrosArchivo = 0;
	RegistroRef p; // Un puntero temporal
	int i;
	// Si se intenta abrir un archivo inexistente, fopen() devuelve NULL
	if (NULL == fp)
		{
			printf("\n\nNo se ha encontrado el fichero de datos.\n\n");
			g->numRegistros = 5;
			p = malloc(g->numRegistros*sizeof(Registro)); // Base de datos vaca
			// Los marcamos como disponibles
			for(i=0;i<g->numRegistros;i++)
				p[i].disponible = 1;
			printf("\n\nSe ha creado una base de datos vaca con %d elementos.\n\n",
							g->numRegistros);
		}
	else
		{
			// Si existe realmente el archivo,
			// saltar al final del archivo
			fseek(fp,0,SEEK_END); 
			// Ver la longitud del archivo
			numBytesArchivo = ftell(fp);
			// Volver al principio, equivale a rewind(fp)
			fseek(fp,0,SEEK_SET); 
			numRegistrosArchivo = numBytesArchivo/sizeof(Registro);
			// Reservamos espacio para 50 registros mas
			g->numRegistros = numRegistrosArchivo + 50;
			p = malloc(g->numRegistros*sizeof(Registro)); // Base de datos vaca
			// Los marcamos como disponibles
			for(i=0;i<g->numRegistros;i++)
				p[i].disponible = 1;
			// Finalmente, leemos los registros que realmente existen
			if (numRegistrosArchivo) // Si hay al menos un registro
				{
					fread(p,sizeof(Registro),numRegistrosArchivo,fp);
					// Y cerramos el archivo
				}
			fclose(fp);
		}
	/*************************************************************/
	g->bd = p; // Se almacena en bd la direccin del bloque
	/*************************************************************/
	g->salirDePrograma = 0; // No se va a salir en el momento de la entrada */
}


void parada(GlobRef g)
{
	FILE * fp;
	int i;
	fp = fopen("datos.bin", "w");
	RegistroRef p = g->bd;
	for(i=0;i<g->numRegistros;i++,p++)
		if (-1 != p->telefono)
			fwrite(p,sizeof(Registro),1,fp);
	fclose(fp);
}

void ayuda(GlobRef g)
{
	printf("\n\nEste es el mecanismo de ayuda.\n\n");
}
