#include <stdio.h>
#include <coti/utiles.h>
#include <math.h>
/*
 * Problema: las funciones strsep() y fgetln() no forman parte
 * del compilador 3.4.2. Cabe suponer que se actualice el soporte
 * de la versin 4.x de este compilador en futuras versiones
 * de Eclipse.
 */
typedef struct Matriz {
	double * m;
	int numFilas, numCols;
} Matriz;

typedef Matriz * pMatriz;

pMatriz matSum(pMatriz r, pMatriz s);
pMatriz matLee(int numFilas, int numCols);
void matPrintf(pMatriz p);

int main(int n, char * p[])
{
	pMatriz m1, m2, m3;
	printf("\n\nSuma de matrices\n================\n\n");
	printf("Escriba la primera matriz:\n\n");
	m1 = matLee(3,3);
	printf("\n\nEscriba la segunda matriz:\n\n");
	m2 = matLee(3,3);
	printf("\n\nLos sumandos son:\n\n");
	matPrintf(m1);
	printf("\n\ny\n\n");
	matPrintf(m2);
	printf("\n\nLa suma es:\n\n");
	m3 = matSum(m1,m2);
	matPrintf(m3);
	return 0;
}

pMatriz matSum(pMatriz r, pMatriz s)
{
	doubleRef m1 = r->m;
	doubleRef m2 = s->m;
	doubleRef m3 = malloc(r->numFilas*r->numCols*sizeof(double));
	int i;
	pMatriz matriz_resultado = malloc(sizeof(Matriz));
	matriz_resultado->numFilas = r->numFilas;
	matriz_resultado->numCols = r->numCols;
	matriz_resultado->m = m3;
	for(i=0;i<r->numFilas*r->numCols;i++)
		{
			m3[i] = m1[i] + m2[i];
		}
	return matriz_resultado;
}

pMatriz matLee(int numFilas, int numCols)
{
	doubleRef m = malloc(numFilas*numCols*sizeof(double));
	pMatriz r = malloc(sizeof(Matriz));
	int i,j;
	char peticion[32];
	r->numFilas = numFilas;
	r->numCols = numCols;
	r->m = m;
	for(i=0;i<3;i++)
		{
			printf("\nFila %d\n\n",i);
			for(j=0;j<3;j++)
				{
					sprintf(peticion,"m[%d][%d] = ",i,j);
					*(m + i*numCols + j) = pedirDouble(peticion,-HUGE_VALF, HUGE_VALF);
				}
		}
	return r;
}


void matPrintf(pMatriz p)
{
	int i,j;
	doubleRef m = p->m;
	int numFilas = p->numFilas;
	int numCols = p->numCols;
	for(i=0;i<numFilas;i++)
		{
			printf("| ");
			for(j=0;j<numCols;j++)
				printf("%6.2f", *(m+i*numCols + j));
			printf(" |\n");
		}
}
