#include "Registro.h"
#include <string.h>

charRef toDelimString(RegistroRef r, charRef d) {
	charRef c = NULL;
	charRef temp = malloc(1024);
	sprintf(temp, "%s%s%d%s%f", r->nombre, d, r->edad, d, r->talla);
	c = malloc(strlen(temp) + 1);
	strcpy(c, temp);
	free(temp);
	return c;
}

charRef toEncolString(RegistroRef r, intRef w) {
	charRef c = NULL;
	charRef fmt = malloc(1024);
	charRef tempFormat = malloc(10);
	charRef temp = malloc(1024);
	sprintf(tempFormat, "%%%ds", w[0]);
	strcpy(fmt, "");
	strcat(fmt, tempFormat);
	sprintf(tempFormat, "%%%dd", w[1]);
	strcat(fmt, tempFormat);
	sprintf(tempFormat, "%%%df", w[2]);
	strcat(fmt, tempFormat);
	sprintf(temp, fmt, r->nombre, r->edad, r->talla);
	c = malloc(strlen(temp) + 1);
	strcpy(c, temp);
	free(temp);
	free(fmt);
	return c;
}

RegistroRef toRecordFromDelimited(charRef s, charRef d) {
	charRef copia = malloc(strlen(s) + 1);
	int numCampos = 0;
	int i;
	charRef * campos = NULL;
	charRef nombre, edad, talla;
	RegistroRef r = malloc(sizeof(Registro));
	strcpy(copia, s);
	for (i = 0; i < strlen(copia); i++)
		if (copia[i] == *d)
			numCampos++;
	numCampos++;
	campos = malloc(sizeof(charRef) * numCampos);
	for (i = 0; i < numCampos; i++)
		campos[i] = strtok(copia, d);

	nombre = campos[0];
	edad = campos[1];
	talla = campos[2];

	strcpy(r->nombre, nombre);
	r->edad = strtol(edad, NULL, 10);
	r->talla = strtof(talla, NULL);

	return r;
}

RegistroRef toRecordFromColumnar(charRef s, intRef w) {
	RegistroRef r = NULL;
	char c1[128], c2[128], c3[128];
	memset(c1, '\0', 128);
	memset(c2, '\0', 128);
	memset(c3, '\0', 128);
	strncpy(c1, s, w[0]);
	trim(c1);
	strncpy(c2, s + w[0], w[1]);
	trim(c2);
	strncpy(c3, s + w[0] + w[1], w[2]);
	trim(c3);
	printf("c1 = \"%s\", c2 = \"%s\", c3 = \"%s\"\n", c1, c2, c3);
	r = malloc(sizeof(Registro));
	strncpy(r->nombre, c1, sizeof(r->nombre) - 1);
	r->nombre[sizeof(r->nombre) - 1] = '\0';// si hay truncacin
	r->edad = strtol(c2, NULL, 10);
	r->talla = strtof(c3, NULL);
	return r;
}

void trim(charRef c) {
	char temp[128];
	int i, firstNonWhitespace = 0, lastNonWhitespace = 0;
	if (!c || !strlen(c))
		return;// Return if c is NULL or string is empty.
	memset(temp, '\0', 128);
	strcpy(temp, c);
	for (i = 0; i < strlen(temp); i++)
		if (!isspace(temp[i])) {
			firstNonWhitespace = i;
			break;
		}
	for (i = strlen(temp) - 1; i > 0; i--)
		if (!isspace(temp[i])) {
			lastNonWhitespace = i;
			break;
		}
	// Trimmed contents are between firstNonWhitespace and lasNonWhitespace
	strncpy(c, &temp[firstNonWhitespace], lastNonWhitespace
			- firstNonWhitespace + 1);
	c[lastNonWhitespace - firstNonWhitespace + 1] = '\0';
}
