#include <stdio.h>
#include <coti/utiles.h>
#include "modelo.h"
/*
	Estas dos funciones existen en todas las aplicaciones.
*/
int volver(ModeloRef);
int salir(ModeloRef);

int main(int argc, char * argv[])
{
	PuntFuncion fm[256];
	charRef orden;
	char opcion;
	int i;
	/*
		 INTERFAZ DE USUARIO - ADAPTAR
	*/
	charRef titulo      = "Listas enlazadas no lineales";
	charRef menu        = "\
A) Aadir al ppio    B) Aadir al final\n\
C) Quitar ppio       D) Quitar final\n\
E) Vaciar lista      F) Insertar ordenado\n\
G) Borrar nodo       M) Mostrar lista\n\
S) Salir\n\
                     Seleccione una opcin --> ";
	char opciones[]     = "ABCDEFGMS";
	PuntFuncion fp[]    = { 
													ponerPrincipio,
													ponerFinal,
													quitarPrincipio,
													quitarFinal,
													vaciarLista,
													insertarOrdenado,
													borrarNodo,
													mostrarLista,
													salir,
													NULL
												};
	/*
		PREPARACIN DEL MODELO - adaptar iniciacion()
	*/
	ModeloRef m = malloc(sizeof(Modelo));
	
	if (!m)
		{
			printf("\nError fatal ... saliendo.\n\n");
			printf("\a\a\a");
			return 1;
		}
	iniciacion(m);
	/*
	 NO MODIFICAR
				|
				|
				V
	*/
	for(i=0;i<256;i++) fm[i] = volver;
	for(i=0;fp[i] != NULL;i++) fm[opciones[i]] = fp[i];
	if (strlen(opciones) != i)
		{
			printf("\n\nNmero de opciones != Nmero de funciones\n\n");
			printf("\a\a\a");
			return 2;
		}
	/*
		Ejecucin del programa
	*/
	printf("\n\n%s\n\n", titulo);
	do
		{
			orden = pedir(menu);
			opcion = toupper(orden[0]);
			fm[opcion](m);
		} while (m->continuar);
			
	return 0;
}

int volver(ModeloRef m)
{
	/* Esta funcin no cambiar */
	printf("\a"); /* Para denotar que esa opcin no es correcta */
	return 0;
}
int salir(ModeloRef m)
{
	/*
		Esta funcin se puede emplear, por ejemplo,
	  para guardar cambios (si los hay) antes de salir.
	*/
	m->continuar = 0;
	return 0;
}
